/* ̧قDoxygenpɏĂ܂B				 */
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: sensor_three_phase_BLDC.c
* - ߲		: IAR EWAAVR 2.28a/3.10c
* - xҰ		: avr@atmel.com
* - x޲	: /13PWMقAO݊荞݂gƂ
*				  SĂ޲
*				  AT90CAN128pɏĂ܂B
* - pLq	: AVR452 - AT90CAN128܂ATmega128ł̊mɊÂ3׼
*				  ȂDCd@̐
* - 		: ]qʒuoΰيmg׼ȂDCd@
*				  AT90CAN128ǂg̗
*
* $Revision: 1.1 $
* $Date: Wednesday, January 25, 2006 07:38:42 UTC $
*****************************************************************************
*
* d@̪
*
* M	AT90CAN128
*
*
* WL		PB7
* VL		PB6
* UL		PB5
* WH		PB4
* VH		PB3
* UH		PB2
*
* Hall C	PE7
* Hall B	PE6
* Hall A	PE5
*
*******************************************************************************
*  CAN\ݒ
*
*  8MHzؽق100kbps
*
*  ̖ړIΏۂɑ邱ƂłCANڰ
*
*
*  ^			id		ް		
*  ް ڰ	0x120	֌W		d@~
*  ް ڰ	0x121	֌W		d@Jn
*  ް ڰ	0x122	HH LL		d@xݒ(x=OxHHLL)
*  ް ڰ	0x123	XX			d@]ݒ(XX=O=CCW܂XX=1=CW)
*  uڰ		0x124	-----		肵xl߂ɂDLC=2
*
*******************************************************************************/

#include <ioavr.h>
#include "mcu.h"
#include "compiler.h"

#include <inavr.h>
#include "sensor_three_phase_BLDC.h"


/*! \brief CCW]͗l^
 *
 * vƔvp̊e푊݋쓮lƌvCOMޯĂ̍\ݒ
 */

unsigned char drvPatternsCCW[] = {0,0x30,0x44,0x50,0x88,0x28,0x84,0x83,0X23,0X23,0X0B,0X83,0x0B};
unsigned char drvPatternsCW[] =  {0,0X84,0X28,0x88,0X50,0X44,0X30,0x0B,0x83,0X0B,0X23,0X23,0x83};

unsigned int speed=0x100,measured_speed;
unsigned char num_channel, num_data,direction=CLOCKWISE;

__regvar __no_init unsigned char *pDrvPattern @14;

__regvar __no_init union _fastTemp{
	unsigned int word;
	struct{
		unsigned char LByte;
		unsigned char HByte;	// Hbyte = 0
	};
} fastTemp @12;


__regvar __no_init unsigned char hallMask @11;	//!< ߲׈ُp̑΍
__regvar __no_init unsigned char count @10;		//!< ݕω荞ݖɑ₳œKꂽϐ

//! ݕω荞ݏٰ
void Hall_ISR(void)
{
	unsigned char *pTemp;
	fastTemp.word = ((PIN_HALL & hallMask)>>5);		// mǂݍ݁AݎՕAʒuwqψʂƂĎg߂ޯĈړ

	pTemp = pDrvPattern + fastTemp.word;

	PORT_MC = *(pTemp);								// High쓮ٕύX

	TCCR1A = *(pTemp + PATTERN_COM1_OFFSET);		// T/C1Ŕrč\ݒ
}


#pragma vector=INT5_vect		//! ݕω荞ݏٰ
__interrupt void INT5_ISR(void)
{
	count++;				// xɎgϐ
	Hall_ISR();
}

#pragma vector=INT6_vect		//! ݕω荞ݏٰ
__interrupt void INT6_ISR(void)
{   Hall_ISR(); }

#pragma vector=INT7_vect		//! ݕω荞ݏٰ
__interrupt void INT7_ISR(void)
{  Hall_ISR(); }

#pragma vector=TIMER0_OVF_vect
__interrupt void   TIMER0_0VF_ISR(void)
{
	// vZ8MHz̸ؽقɑ΂čs܂B
	// count = (8MHz)32,768msnb loop
	// measured_speed = nb loop
	// : count = 29 --> nbloop = 29/2 (2mŌJԂ)
	// 60b/0.032768 = 1831
	//  8 = 4*2
	// (29~1831.05) / 8 = 6637
	// ʂ4(ɐ)2(2mŌJԂ)ŏZȂ΂Ȃ܂B
	// (wȂ)肵ő呬x6637JԂ/łB

	measured_speed = (count*1831)>>3;
	count=0;
}


//! ߰B5,6,7݂ݕω荞ݏ
void Init_MC_pin_change_interrupt( void )
{
	EICRB = 0x54;	// int5 int6 int7 (PE5,PE6,PE7)݂ٕωł̊荞݂ɍ\ݒ
	EIMSK = 0xE0;	// int 5 6 7
}


//! v0𑬓xpɏ
void Init_Speed_Timer0(void)
{
	TCCR0A  = (0<<COM0A1)|(0<<COM0A0)|
			  (0<<FOC0A) |(0<<WGM00) |(0<<WGM01)|
			  (0<<CS02)  |(0<<CS01)  |(1<<CS00);

	TIMSK0 =  (0<<OCIE0A)|(1<<TOIE0);
}


//! d@v평
void Init_MC_timer1_pwm( void )
{
	// 10ޯčPWM
	TCNT1=0x00;

	TCCR1A = (1<<COM1A1)|(1<<COM1A0)|		// rvOCR1A
			 (0<<COM1B1)|(0<<COM1B0)|		// rvOCR1B
			 (0<<COM1C1)|(0<<COM1C0)|		// rvOCR1C
			 (1<<WGM11)|(1<<WGM10);

	TCCR1B = (0<<ICNC1)|(0<<ICES1)|
			 (0<<WGM13)|(1<<WGM12)|			// PWM
			 (0<<CS12)|(0<<CS11)|(1<<CS10);	// Ou=CLK/1

  TIFR1 = TIFR1;							// T/C1荞ݗv̱މ */
}


//! PWMޭè قœd@xݒ
void Set_Speed(unsigned int speed)
{
	TIFR1 = TIFR1;					// T/C1荞ݗv׸މ
	while( !(TIFR1 & (1<<TOV1)));	// vőSڼ޽XVmɂ邽TOV҂
	__disable_interrupt();

	// ޭè ٕύX
	OCR1AL = speed;
	OCR1AH = speed>>8;
	OCR1BL = speed;
	OCR1BH = speed>>8;
	OCR1CL = speed;
	OCR1CH = speed>>8;
	__enable_interrupt();
}


//! d@CW܂CCWɐݒ
void Set_Direction(unsigned char direction)
{
	if(direction == CLOCKWISE)
	{
		__disable_interrupt();			// 荞݂łgϐ̂߁A͕ی삳Ȃ΂Ȃ܂B
		pDrvPattern = drvPatternsCW;	// CW͗l^wƂɂĕCWɐݒ
		EIFR=EIFR;						// ǂۗ̕荞݂
		__enable_interrupt();
	}
	else
	{
		__disable_interrupt();			// 荞݂łgϐ̂߁A͕ی삳Ȃ΂Ȃ܂B
		pDrvPattern = drvPatternsCCW;	// CCW͗l^wƂɂĕCCWɐݒ
		EIFR=EIFR;						// ǂۗ̕荞݂
		__enable_interrupt();
	}
}

//! ߰āAvA
void motor_init()
{
	__disable_interrupt();
	MCUCR |= (1<<PUD);					// Sٱߋ֎~
	hallMask = HALL_MASK;				// ΰيmՕϐ

//	Init_MC_timers();
	Init_MC_timer1_pwm();				// PWMɎgv1
	Init_MC_pin_change_interrupt();		// ΰيm튄荞ݗpݏ
	Init_Speed_Timer0();				// xvZɎgv
	// x
	Set_Speed(speed);
	// ݒ
	Set_Direction(direction);
	DDR_HALL |= HALL_MASK;				// ΰيm쓮邱ƂɂΰيmŒ艻
	PORT_HALL |= HALL_MASK;
	PORT_HALL &= ~HALL_MASK;			// ΰيmJPC荞݂N
	DDR_HALL &= ~HALL_MASK;
	EIFR=EIFR;
	__enable_interrupt();
	DDR_MC |= 0xFF;
	DDRB|=0xFF;
}


void Run_motor(void)
{  DDR_MC  = 0xFF; }


void Stop_motor(void)
{  DDR_MC  = 0x00; }


void can_init(void)		// 0ڰт󂯎A1ڰт𑗂ACANϸ
{
	CANGCON |= MSK_CANGCON_GRES;		/* CANؾ */
	/* SҰޯؾ */
	for (num_channel = 0; num_channel < 15; num_channel++)
	{
		CANPAGE  = num_channel << 4;
		CANCDMOB = CH_DISABLE;
		CANSTMOB  = 0;
		CANIDT1  = 0;
		CANIDT2  = 0;
		CANIDT3  = 0;
		CANIDT4  = 0;
		CANIDM1  = 0;
		CANIDM2  = 0;
		CANIDM3  = 0;
		CANIDM4  = 0;
		for (num_data = 0; num_data < 8; num_data++) CANMSG = 0;
	}
	/* 8MHzؽق100kbpsłݸނɐݒ */
	CANBT1  = 0x08;
	CANBT2  = 0x0C;
	CANBT3  = 0x37;
	CANGCON |=  MSK_CANGCON_ENA;		/* CANJn */

	/* 0 */
	CANPAGE = (0 << 4);					/* CHNB=0x00; 0I */
	CANSTMOB  = 0x00;					/* ُؾ */
	CANCDMOB = CH_DISABLE;				/* /DLCڼ޽ؾ */

	/* 0: ʕ[=11ޯāACANIDT=0x123 */
	CANIDT1 = 0x24;
	CANIDT2 = 0x60;

	/* 0: Օ=11ޯāA0x7F0 */
	CANIDM1 = 0xFE;
	CANIDM2 &= ~0xE0;
	CANIDM4 = 0;

	/* 0\ݒ */
	CANIDT4 &=~0x04;					/* CANIDT4RTRޯĉ */
	CANCDMOB |= DLC_MAX;				/* 8޲ĎM */
	CANCDMOB |= CH_RxENA;				/* ɏՂȂM */

	/* 1 */
	CANPAGE = (1 << 4);					/* CHNB=0x01; 1I */
	CANSTMOB  = 0x00;					/* ُؾ */
	CANCDMOB = CH_DISABLE;				/* /DLCڼ޽ؾ */

	/* 1: ʕ[=11ޯāACANIDT=0x123 */
	CANIDT1 = 0x24;
	CANIDT2 = 0x60;

	/* 1: Օ=11ޯāA0x7F0 */
	CANIDM1 = 0xFE;
	CANIDM2 &= ~0xE0;
	CANIDM4 = 0;
	/* 荞ݍ\ݒ */
	CANIE2|=0x01;						/* IECH0=1 */
	CANGIE = ((1<<ENRX)|(1<<ENIT));		/* CANMƊ荞݂ */
}


#pragma vector=CANIT_vect		// CAN ISR
__interrupt void  CAN_ISR(void)
{
	unsigned int id;								/* can_datawW */

	/* 0MŎ󂯎ް𑗂Ԃ */
	CANPAGE = (0 << 4);								/* CHNB=0x00; 0I */
	if((CANSTMOB & MSK_CANSTMOB_RxOk) == MSK_CANSTMOB_RxOk)
	{
		id = (((int)(CANIDT2))>>5) + (((int)(CANIDT1))<<3);		// V2.0A
		switch(id)
		{
			case(0x120): 		// d@~
				Stop_motor();
				break;

			case(0x121):		// d@s
				Run_motor();
				break;

			case(0x122):		// xݒ
				speed=(((int)(CANMSG))<<8);
				speed = speed + (int)(CANMSG);
				break;

			case(0x123):		// d@ݒ
				direction=CANMSG;
				break;

			case(0x124):		// 肵x𑗂Ԃ
				if ( (CANIDT4 & 0x04) == 0x04)
				{
					CANPAGE = (1 << 4);				/* 1I */
					CANIDT2 = (char)(id << 5);
					CANIDT1 = (char)(id >> 3);
					CANMSG = (char)(measured_speed >> 8);
					CANMSG = (char)(measured_speed);
					CANSTMOB = 0x00;
					CANCDMOB = 0x02;				/* 2޲đo */
					CANCDMOB |= CH_TxENA;			/* o */
//					CANEN2 |= (1 << 1);				/* 1 */
					CANPAGE = (0 << 4);				// 0I
				}
				break;
		}
	}

	CANPAGE = (0 << 4);
	CANSTMOB=0x00;									/* 0ؾ */
	CANEN2 |= (1 << 0);								/* 0 */
	CANCDMOB = DLC_MAX;								/* 8޲ĎM */
	CANCDMOB |= CH_RxENA;							/* M */
	CANGIT = CANGIT;								/* S׸ ؾ */
}


void main( void )
{
	motor_init();
	can_init();

	for(;;)		// xƕXV
	{
		Set_Speed(speed);
		Set_Direction(direction);
	}
}
